#! /bin/bash

# cd to current path
dirname=`dirname $0`
tmp="${dirname#?}"
if [ "${dirname%$tmp}" != "/" ]; then
	dirname=$PWD/$dirname
fi

echo $dirname
cd "$dirname"

# close driver if it running
AppName=huiontablet
AppDir=huiontablet
pid=`ps -e|grep $AppName`
AppCoreName=huionCore
AppUIName=huiontablet

#Close running driver
#echo "close core"
sudo killall huionCore
#echo "close tablet"
sudo killall huiontablet

#Copy rule
sysRuleDir="/usr/lib/udev/rules.d"
sysRuleDir2="/lib/udev/rules.d"
appRuleDir=./huion/huiontablet/res/rule
ruleName="20-huion.rules"

#echo "$appRuleDir/$ruleName"
#echo "$sysRuleDir/$ruleName"
if [ -f $appRuleDir/$ruleName ]; then
	str=`cp $appRuleDir/$ruleName $sysRuleDir/$ruleName`
	if [ "$str" !=  "" ]; then 
		echo "$str";
		str=`cp $appRuleDir/$ruleName $sysRuleDir2/$ruleName`
		if [ "$str" !=  "" ]; then 
			echo "Sstr";
		fi
	fi
else
	echo "Cannot find driver's rules in package"
	exit
fi

#install app
sysAppDir="/usr/lib"
appAppDir=./huion/$AppName
exeShell="huionCore.sh"

echo $sysAppDir
echo $appAppDir

if [ -d "$appAppDir" ]; then
	str=`cp -rf $appAppDir $sysAppDir`
	if [ "$str" !=  "" ]; then 
		echo "$str";
	fi
else
	echo "Cannot find driver's files in package"
	exit
fi

#echo "shell path "$AppDir/$exeShell
if [ -f $sysAppDir/$AppDir/$exeShell ]; then
	str=`chmod +0755 $sysAppDir/$AppName/$exeShell`
	if [ "$str" !=  "" ]; then 
		echo "Cannot add permission to start script"
		echo "$str";
		exit
	fi
else
	echo "can not find start script"
	exit
fi

#echo "exe path "$sysAppDir/$AppDir/$AppCoreName
if [ -f $sysAppDir/$AppDir/$AppCoreName ]; then
	str=`chmod +0755 $sysAppDir/$AppDir/$AppCoreName`
	if [ "$str" !=  "" ]; then 
		echo "Cannot add permission to app Core"
		echo "$str";
		exit
	fi
else
	echo "can not find app Core"
	exit
fi

#echo "exe path "$sysAppDir/$AppDir/$AppUIName
if [ -f $sysAppDir/$AppDir/$AppUIName ]; then
	str=`chmod +0755 $sysAppDir/$AppDir/$AppUIName`
	if [ "$str" !=  "" ]; then 
		echo "Cannot add permission to app UI"
		echo "$str";
		exit
	fi
else
	echo "can not find app UI"
	exit
fi

#echo "exe path "$sysAppDir/$AppDir/HuionCore.pid
if [ -f $sysAppDir/$AppDir/HuionCore.pid ]; then
	str=`chmod 0766 $sysAppDir/$AppDir/HuionCore.pid`
	if [ "$str" !=  "" ]; then 
		echo "Cannot add permission to HuionCore.pid"
		echo "$str";
		exit
	fi
else
	echo "can not find HuionCore.pid"
	exit
fi

if [ -f $sysAppDir/$AppDir/DriverUI.pid ]; then
	str=`chmod 0766 $sysAppDir/$AppDir/DriverUI.pid`
	if [ "$str" !=  "" ]; then 
		echo "Cannot add permission to DriverUI.pid"
		echo "$str";
		exit
	fi
else
	echo "can not find DriverUI.pid"
	exit
fi

if [ -f $sysAppDir/$AppDir/log.conf ]; then
	str=`chmod 766 $sysAppDir/$AppDir/log.conf`
	if [ "$str" !=  "" ]; then 
		echo "Cannot add permission to log.conf"
		echo "$str";
		exit
	fi
else
	echo "can not find log.conf"
	exit
fi

if [ -f $sysAppDir/$AppDir/huion.log ]; then
	str=`chmod 766 $sysAppDir/$AppDir/huion.log`
	if [ "$str" !=  "" ]; then 
		echo "Cannot add permission to huion.log"
		echo "$str";
		exit
	fi
else
	echo "can not find huion.log"
	exit
fi

# install shortcut
sysDesktopDir=/usr/share/applications
sysAppIconDir=/usr/share/icons
sysAutoStartDir=/etc/xdg/autostart

appDesktopDir=./huion/xdg/autostart/
appAppIconDir=./huion/icon/
appAutoStartDir=./huion/xdg/autostart/

appDesktopName=$AppName.desktop
appIconName=$AppName.png


if [ -f $appDesktopDir/$appDesktopName ]; then
	str=`cp $appDesktopDir/$appDesktopName $sysDesktopDir/$appDesktopName`
	if [ "$str" !=  "" ]; then 
		echo "$str";
	fi
else
	echo "Cannot find driver's shortcut in package"
	exit
fi

if [ -f $appAppIconDir/$appIconName ]; then
	str=`cp $appAppIconDir/$appIconName $sysAppIconDir/$appIconName`
	if [ "$str" !=  "" ]; then 
		echo "$str";
	fi
	#echo $sysAppIconDir/$appIconName
	stricon=`chmod 0766 $sysAppIconDir/$appIconName`
	if [ "$stricon" !=  "" ]; then 
		echo "Cannot add permission to app icon"
		echo "$str";
		exit
	fi
else
	echo "Cannot find driver's icon in package"
	exit
fi

if [ -f $appAutoStartDir/$appDesktopName ]; then
	str=`cp $appAutoStartDir/$appDesktopName $sysAutoStartDir/$appDesktopName`
	if [ "$str" !=  "" ]; then 
		echo "$str";
	fi
	
else
	echo "Cannot find set auto start"
	exit
fi

#Copy config files
#echo $sysAppDir/$AppDir/res
strres=`chmod -R +0766 /usr/lib/huiontablet`
if [ "$strres" !=  "" ]; then 
	echo "Cannot add permission to res"
	echo "$strres";
	exit
fi


echo "Installation Succeeded !"
echo "Please reboot your Linux device to run the driver, or the driver will not be useful."

